cell_size=5
targetcell=100
lambdacell=10.0
def configureSimulation(sim):
    import CompuCellSetup
    from XMLUtils import ElementCC3D
    
    CompuCell3DElmnt=ElementCC3D("CompuCell3D",{"Revision":"20160414","Version":"3.7.5"})
    
    PottsElmnt=CompuCell3DElmnt.ElementCC3D("Potts")
    
    # Basic properties of CPM (GGH) algorithm
    PottsElmnt.ElementCC3D("Dimensions",{"x":"512","y":"512","z":"1"})
    PottsElmnt.ElementCC3D("Steps",{},"1000000")
    PottsElmnt.ElementCC3D("Temperature",{},"10.0")
    PottsElmnt.ElementCC3D("NeighborOrder",{},"2")

    Meta = CompuCell3DElmnt.ElementCC3D("Metadata")
    Meta.ElementCC3D("NumberOfProcessors", {}, 8)

    PluginElmnt=CompuCell3DElmnt.ElementCC3D("Plugin",{"Name":"CellType"})
    
    # Listing all cell types in the simulation
    PluginElmnt.ElementCC3D("CellType",{"TypeId":"0","TypeName":"Medium"})
    PluginElmnt.ElementCC3D("CellType",{"TypeId":"1","TypeName":"stem"})
    
    CompuCell3DElmnt.ElementCC3D("Plugin",{"Name":"Volume"})
    
    PluginElmnt_1=CompuCell3DElmnt.ElementCC3D("Plugin",{"Name":"CenterOfMass"})
    
    # Module tracking center of mass of each cell
    
    PluginElmnt_2=CompuCell3DElmnt.ElementCC3D("Plugin",{"Name":"Contact"})
    # Specification of adhesion energies
    PluginElmnt_2.ElementCC3D("Energy",{"Type1":"Medium","Type2":"Medium"},"10.0")
    PluginElmnt_2.ElementCC3D("Energy",{"Type1":"Medium","Type2":"stem"},"10.0")
    PluginElmnt_2.ElementCC3D("Energy",{"Type1":"stem","Type2":"stem"},"10.0")
    PluginElmnt_2.ElementCC3D("NeighborOrder",{},"4")

    ntp = CompuCell3DElmnt.ElementCC3D("Plugin", {"Name": "NeighborTracker"})

    CompuCellSetup.setSimulationXMLDescription(CompuCell3DElmnt)            
    CompuCellSetup.setSimulationXMLDescription(CompuCell3DElmnt)
            
import sys
from os import environ
from os import getcwd
import string

sys.path.append(environ["PYTHON_MODULE_PATH"])


import CompuCellSetup


sim,simthread = CompuCellSetup.getCoreSimulationObjects()
        
configureSimulation(sim)            
                
# add extra attributes here
            
CompuCellSetup.initializeSimulationObjects(sim,simthread)
# Definitions of additional Python-managed fields go here
        
#Add Python steppables here
steppableRegistry=CompuCellSetup.getSteppableRegistry()
        

from lineageSteppables import ConstraintInitializerSteppable
ConstraintInitializerSteppableInstance=ConstraintInitializerSteppable(sim,1,cell_size,lambdacell,targetcell)
steppableRegistry.registerSteppable(ConstraintInitializerSteppableInstance)
        

from lineageSteppables import GrowthSteppable
GrowthSteppableInstance=GrowthSteppable(sim,_frequency=1)
steppableRegistry.registerSteppable(GrowthSteppableInstance)
        
from lineageSteppables import DeathSteppable
DeathSteppableInstance=DeathSteppable(sim,_frequency=1)
steppableRegistry.registerSteppable(DeathSteppableInstance)

from lineageSteppables import MitosisSteppable
MitosisSteppableInstance=MitosisSteppable(sim,1,cell_size,targetcell,lambdacell)
steppableRegistry.registerSteppable(MitosisSteppableInstance)

from lineageSteppables import histocells
histInstance=histocells(sim,1)
steppableRegistry.registerSteppable(histInstance)

CompuCellSetup.mainLoop(sim,simthread,steppableRegistry)
        
        